/* tslint:disable */
import {lang_en} from "./en";
import {isProduction} from "../debug";
import Logger from "../src/helpers/logger";
import * as React from 'react'

export interface LangObj {

  //---pagination
  "Total items": string
  "Rows per page": string
  //--- common
  "Next": string
  "Previous": string
  "There is an option issue with this feature/function:": string
  "Yes": string
  "No": string
  "Ok": string
  "Internal error (see console)": string
  "Error": string
  "Warning": string
  "Add": string
  "Result": string
  "Other": string
  "Save": string
  "Change": string
  "Edit": string
  "Manage": string
  "Delete": string
  "Cancel": string
  "Open": string
  "Close": string
  "Copy": string
  "Resume": string
  "Version": string
  "To resume click the button. This will set the clipboard content to a single whitespace.": string
  "Is release open": string
  "Hints": string
  "Text": string
  "Icon": string
  "Server error": string
  "Language": string
  "Miscellaneous": string
  "Discard": string
  "Created at": string
  "Last updated at": string
  "Last login at": string
  "Information": string
  "Search": string
  "Link": string
  "Will only select all items on the current page": string
  "Could not load site data": string,
  "It seems like you have some unsaved changes. Are you really sure you want to logout?": string,
  "You might have some unsaved changes. Are you sure you want to logout?": string,
  "No permission": string
  "Click to clear": string
  "Could not connect to the server (the server might be offline), probably a server maintenance is the reason. If the problem persists, contact:": string
  "Could not connect to the server (the server might be offline), probably a server maintenance is the reason. You can keep this tab open (e.g. if you have unsaved changes) and try it later again. Every action that requires connecting to the server will do the state check. If the problem persists, contact:": string
  "Shortcut: ctrl+0/cmd+0. Resets the quick-zoom to the zoom in the editor settings. Note that the quick-zoom is not persistent": string
  "Shortcut: ctrl++/cmd++": string
  "Shortcut: ctrl+-/cmd+-": string
  "Could not get the server time, thus the displayed (left) times are probably wrong. The server is probably offline.": string
  "Print the current file only": string
  "Print all files, one per page": string
  "Print all files consecutively": string
  "Select an option...": string
  "Owner": string
  "Owner was not loaded, id:": string
  "Privacy policy": string
  "Download personal data": string
  "This will download all your personal data that we store into a zip file. This can take some time!": string
  "Copyright page": string
  "About page": string

  "Password and Password again were different": string

  //--- error messages
  "Field must not be empty or just whitespaces": string
  "Invalid editor theme": string
  "Invalid option, take other": string
  "Field value is not a valid email": string
  "Available working time must be set and >= 1": string

  //dialogs
  "Delete custom test": string
  "Are you sure you want to delete the custom test?": string
  "Reset code": string
  "Are you sure you want to reset your code to the template?": string
  "Are you sure you want to reset your code to your submitted solution?": string
  "Are you sure you want to delete the group role?": string
  "This is a default group role and cannot be deleted": string
  "Leave group": string
  "Are you sure you want to leave the group?": string
  "Delete group": string
  "Are you sure you want to delete the group? This will also delete all exercises (and connected releases) managed by this group.": string
  "Delete new user": string
  "Are you sure you want to delete the new user?": string
  "Activated selected user(s)": string
  "Are you sure you want to activate the selected user(s)?": string
  "Delete not activated user(s)": string
  "Are you sure you want to delete the not activated user(s)?": string
  "Delete activated user": string
  "Are you sure you want to delete the activated user?": string
  "Are you really sure you want to delete the activated user? This cannot be undone and all data connected to the user is also deleted (solutions, tests, custom projects, ...)! Note that this operation can still fail if the user has a solution for a locked exercise!": string
  "Delete tag": string
  "Are you sure you want to delete the tag?": string
  "Release user from group": string
  "Are you sure you want to release the user from this group?": string
  "Release multiple users from group": string
  "Are you sure you want to release multiple users from this group?": string
  "Delete system role": string
  "Are you sure you want to delete the system role?": string
  "Reset code to submission": string
  "Are your sure you want to reset the code to the submissions code?": string
  "Reset code to subsequent editor": string
  "Are your sure you want to reset the code to the subsequent editor code?": string
  "Delete exercise": string
  "Are you sure you want to delete the exercise?": string
  "Are you sure you want to re-run all automatic assessments?": string
  "Delete release": string
  "Are you sure you want to delete the release? This will also delete all submissions (including assessments)!": string
  "Reset password": string
  "Are you sure you want to reset the password?": string
  "Add users to group": string
  "Are you sure you want to add the selected user(s) to the group?": string
  "Delete file": string
  "Are you sure you want to delete the file": string //question mark is added manually
  "Recover files": string
  "If you press 'Yes' then the new files from your browser are taken. If you press 'No' then the files from server are taken. If you regret your decision you can reload the page and the question will be asked again.": string
  "Are you sure you want to lock the current exercise permanently? You cannot longer update or delete the exercise or any dependent entities. This means pending releases (automatic) will not be released, releases for this exercise cannot be created, updated or deleted. Pending assessments for solutions to this exercise will not run and tutors will not be able to update the assessments. Any changes you made to this exercise (in this view) before clicking this button will not be applied because the exercise then then locked! The exercise will be visible in the group (if not already) and you will not be longer the owner. The exercise will be locked in the group: ": string
  "Are you really sure you want to lock this exercise? This cannot be reverted!": string

  "You cannot longer update or delete the exercise or any dependent entities. This means pending releases (automatic) will not be released, releases for this exercise cannot be created,updated or deleted. Pending assessments for solutions to this exercise will not run and tutors will not be able to update the assessments.": string

  "Detach file": string
  "Are you sure you want to detach the file? If this file is not connected to another exercise the fille will get deleted!": string

  //--- abbreviations
  "h": string
  "m": string,
  "s": string,
  "days": string
  "day": string

  "ms": string
  "kb": string

  //--- editor settings
  "Change Editor settings": string
  "Theme": string
  "Light": string
  "Dark": string
  "We use cookies to store information across sessions.<br /> By signing in you agree to": string
  "Note that an admin needs to activate your account manually after registration": string
  "our use of cookies.": string
  'Default light': string
  'Default dark': string
  "Font size": string
  "Tab size": string
  "Show line numberrs": string
  "Use wrapping": string
  "visual line break": string
  "Show line indentations": string
  "Loading ...": string

  //--- login/sign in form
  "Wrong username or password": string
  "Login": string
  "Username": string
  "Password": string
  "Forgot Password?": string
  "Contact a tutor/exercise instructor, he/she will reset your password.": string
  "Sign In": string
  "Register": string

  //--- register/sign up form
  "The password and the again password don't match.": string
  "Registered": string
  "Register was successful but the Admin needs to activate your account.": string
  "Id": string
  "Token": string
  "Password again": string
  "First name": string
  "Last name": string
  "Email": string

  //--- code editor wrapper
  "This is the main file": string
  "The file content is hidden": string
  "This file was changed since last save": string
  "At least one file has changed": string
  "This file is readonly": string
  "No file selected": string
  "No files": string

  //--- site header bar / site menu
  "Exercises": string
  "Manage exercises": string
  "Manage users": string
  "Manage groups": string
  "All open exercises": string
  "All closed exercises": string
  "Own exercises": string
  "Group exercises": string
  "Groups": string
  "Group roles": string
  "Manage new users": string
  "Manage activated users": string
  "System roles": string
  "System role": string
  "Settings": string
  "Logout error": string
  "Log": string
  "Logout": string
  "Home": string
  "Dashboard": string
  "Open exercises via code": string
  "Open exercises via visibility": string
  "Closed exercises via code": string
  "Closed exercises via visibility": string
  "New exercise": string
  "Manage Tags": string
  "About": string

  //--- about site
  "YAPEX": string
  "YAPEX is a system for programming language independent, automatic testing and assessment of exercises.": string
  "Design": string
  "Frameworks": string
  "Project people": string

  //--- allAccessibleExercisesSite
  "Left working time": string
  "End": string
  "Manual": string
  "Name": string
  "Description": string
  "Release code": string
  "Working time in min": string
  "Working time": string
  "The user has the amount of working time to solve the exercise (started when the user opens the exercise for the first time). When re-releasing a release the working time won't reset!": string
  "Limit": string
  "Max manual points": string
  "The max manual points as note for the students. This is only a hint for the max manual points, you can assign more points than this value. Let this field empty to not set max manual points": string
  "Tags": string
  "Enter release code": string
  "Time left": string
  "Note that the minimum of left working time and automatic end is used": string

  //--- console view
  "Program exit code": string
  "but expected exit code" : string
  "A normal program has an exit code of 0. If you intended an exit code different from 0 then specify this in the test": string

  "compiled in": string
  "executed in": string

  "Test-server version": string
  "Test-runner version": string
  "Used timeout in ms": string
  "Used compile timeout in ms": string
  "Used character limit": string

  "Arguments": string,
  "unknown/ignored line": string
  "The previous (your) output was wrong. This is the correct output. Blue characters are missing, red ones are too much (inside your output) [For regex lines, starting with '(regex):' there is no diff display option].": string
  "The previous (your) output was wrong. This is the correct output.": string
  "Your output must match this regex": string
  "Use diff": string
  "If enabled and your output was wrong then the diff against the expected output is displayed as your output. If disabled the wrong output is marked red instead. For further help (if enabled) hover over the rectangle left to the expected output.": string
  "Replace Spaces": string
  "Replaces all whitespaces with · and all tabs with ⇥ in the input and output": string
  "End of user program": string
  "State": string
  "Compiler error": string
  "Wrong output": string
  "Unknown test type": string
  "Program timeout": string
  "Compile timeout": string
  "A timeout can have 3 main reasons. 1. Your program has an infinite loop (not terminating) 2. Your program tries to read from the console but no input is provided from the test (waiting forever for input) 3. The test(-runner) expects your program to output something (waiting forever for output) but your program doesn't write anything (so you output less than the test expects)": string
  "Disk space limit": string
  "RAM limit": string
  "Unknown test-server error": string
  "User program error": string
  "Test": string
  "Input": string
  "Output": string
  "Program": string
  "The test protocol exceeded the character limit and was truncated. However your test can still pass because character limit is only used to limit the memory used to store the test result. New lines characters are counted as 4 characters. There are some characters (~100) reserved for header data and each test protocol line consumes some additional characters (depending on the protocol entry type).": string

  "Test content read timeout": string
  "Exit code mismatch": string
  "Compare files mismatch": string
  "If this is enabled all error output lines (stderr) will be hidden. Keep in mind that this will also hide any real error message": string
  "If this is enabled all expected output lines will be hidden and only lines from your program are displayed": string

  "Comparing files": string
  "Parse error": string
  "with options": string
  "Equal": string
  "File 1 was not found": string
  "File 2 was not found": string
  "End of file 2 reached": string
  "Line": string
  "END OF FILE": string

  //--- custom tests
  "Create custom test": string
  "Change custom test": string
  "Open help in new tab": string
  "Test content": string
  "You can write to the stderr (with java System.err.println and use it as debug output) and it will be ignored by the test runner (the test will pass if all System.out.println (stdout) are correct). However if you write to stdout and then to stderr the output might print the stderr line before the stdout line, so the order of the lines is only correct for all stdout separately and all stderr separately. The test runner replaced every 0x00 char (e.g. when you print a (char)0 or an not initialized char-array entry) and replaces it with ☐. You can also ouput 3/4 bit ansi color codes via \\033[CODEm (see wikipedia ansi escape code, ubuntu colors are used). Colors are only printed on just run program or if the output was correct. Note that the colors are only set for one line (not like the terminal). After the line the style is reset to normal.": string
  "Test-Server Notes" : string
  "Test-Server Limits" : string
  "Setting" : string

  "Max. tests with one request": string

  "The max time the user program is allowed to run in ms": string
  "The max time the user program is allowed to compile in ms": string
  "If one runs multiple tests this is the number of tests that are actually run with one requests. If there are tests left one must issue a new requests to run all tests": string

  "This value is overwritten by the test-server setting timeout in ms (hardTimeoutInMs) which is the max time the user program can run": string
  "This value is overwritten by the test-server setting compile timeout in ms (hardCompileTimeoutInMs) which is the max time the user program can compile": string
  "This value is overwritten by the system setting just run program timeout in ms (justRunProgramTimeoutInMs) which is the max time the user program can run": string
  "This value is overwritten by the system setting just run program compile timeout in ms (justRunProgramCompileTimeoutInMs) which is the max time the user program can compile": string
  "This value is overwritten by the system setting custom project test timeout in ms (justRunProgramTimeoutInMs) which is the max time the user program can run": string

  "This value is overwritten by the system setting custom project test compile timeout in ms (customProjectTestCompileTimeoutInMs) which is the max time the user program can compile": string

  "This value is overwritten by the system setting test server timeout in ms (testServerTimeoutInMs) which is the request timeout backend to test-server (one request can contain many tests)": string
  "This value is overwritten by the system setting submit test server timeout in ms (submitTestServerTimeoutInMs) which is the request timeout backend to submit test-server (one request can contain many tests)": string

  "This value is overwritten by the test-server setting max RAM in kb (hardMemoryLimitInKb) which is the max memory the user program can use": string
  "This value is overwritten by the system setting just run program max RAM in kb (justRunProgramMemoryLimitInKb) which is the max memory the user program can use": string
  "This value is overwritten by the system setting custom project test max RAM in kb (customProjectTestMemoryLimitInKb) which is the max memory the user program can use": string

  "This value is overwritten by the test-server setting max disk space in kb (hardDiskSpaceLimitInKb) which is the max disk space the user program can use": string
  "This value is overwritten by the system setting just run program max disk space in kb (justRunProgramMaxDiskSpaceInKb) which is the max disk space the user program can use": string
  "This value is overwritten by the system setting custom project test max disk space in kb (customProjectTestMaxDiskSpaceInKb) which is the max disk space the user program can use": string

  "The test-server settings are not available. Thus this setting could be overwritten by some test-server setting": string
  "The test-server settings are not available": string


  "Test content visually": string
  "Test settings & files": string
  "Timeout in ms": string
  "Compile timeout in ms": string
  "Max. RAM in kb": string
  "Max disk space in kb": string
  "Compiler options": string
  "Options passed to the compiler, e.g. for java -Xlint. Multiple arguments must be separated by a whitespace.": string
  "Files": string
  "Run all tests": string
  "Runs all not passed tests. If all tests have passed then all tests are re-run. When at least one test fails then the next x tests are not executed.": string
  "This only discards the results in the frontend, the results on the server are still there": string
  "Max parallel tests": string
  "Editor settings": string
  "Resets your code to the template but does not saves the new code in the editor to the server.": string
  "Resets the code to your readonly solution": string

  //--- submit tests panel
  "you need at least (>= ": string //${percentageNeededToPassedAutomaticAssessment}
  ") to pass the exercise. The weight (points) of the tests is displayed as the background of each test.": string
  "Show content": string

  //--- do exercise editor site
  "Editor": string
  "Editor supports Markdown (Icon)": string
  "Solution editor": string
  "Description editor": string
  "Subsequent editor": string
  "Cannot load some exercise site parts": string
  "Time is up! You can still do the exercise for your own in the subsequent editor (the subsequent solution will not be used for assessment through). To run tests use the life ring test-tabs.": string
  "Could not lock the solution": string
  "Unlock solution for editing" : string
  "Note that locking the solution is optional, your solution will be assessed (maybe by a tutor) regardless if it's locked or not": string
  "Your solution is currently locked for the submission process": string
  "Displays the internal log": string


  //--- after for assessment because of performance probably
  "The editor that is displayed after the release & the automatic assessment have finished. You can try to solve the exercise (again) with this editor BUT you cannot save!": string
  "Task description": string
  "Normal tests": string
  "Normal points": string
  "Max normal points": string
  "Submit points": string
  "Max submit points": string
  "Custom tests": string
  "Submit tests": string
  "Console output": string
  "Could not save files": string
  "Saved files": string
  "You have unsaved changes, do you really want to exit?": string
  "Save all files": string
  "Shortcut: ctrl+s/cmd+s. This will also clear all test results if the code was changed (because they are then invalid)": string
  "Compile single file": string
  "Saves all files (ONLY if the editor has unsaved changes) and compiles the program with the current file as main file.": string
  "Compiles the program with the current file as main file.": string
  "Just Run Program": string
  'Saves all files (ONLY if the editor has unsaved changes) and runs the program without any input (except the given args). If one arg should contain whitespaces enclose it in "" because args are separated by whitespaces. The max length for the program args is ': string
  'If one arg should contain whitespaces enclose it in "" because args are separated by whitespaces. The max length for the program args is ': string
  "Release finished": string


  //--- exercise editor site
  "Create template": string
  "Change template": string
  "Programming language": string
  "Main file": string
  "The main file that will be executed. E.g. in java this is the file with the class containing the main method.": string
  "At least one file is needed": string
  "File name": string
  "Content editable by user": string
  "Readonly files are always up-to-date with the version from the exercise. A copy of the readonly file is still stored in the users solution. If you change from normal to readonly file then the content from the user is not changed but no one can access the file content (backend will always return the up-to-date version from the exercise and not the user file content). If you change from readonly to normal file then the content is the same as the readonly file or if the file was changed by the user (because is was previously a normal file and changed to readonly prior and now back to normal) then the last state (content) is used when the user had saved the file before it got readonly.": string
  "Content is visible for user": string
  "The file content is hidden from the user (empty file is displayed) and is readonly but the file name is visible. If this option is checked it overwrites the readonly option. If you change from hidden to visible to user will get the real user file content. If you change from visible to hidden the user will get a blank file. The user file (with old content) will not get touched/updated only all backend calls will return the blank file. When a user solution is created a copy of the template is created as a user file (this is the real file content). Also note that the user CAN get the file content when the program is executed (e.g. list all files in directory and read them)!": string
  "All programming languages have already a code template.": string
  "This exercise has already releases so you are not able to delete templates, add/remove template files or change the main file to another file.": string
  "You need at least one code template. Only programming languages with a code template will be choosable by the users.": string
  "Users are allowed to create custom tests": string
  "Users are allowed to rename files and create new ones": string
  "Exercise is only visible to owner": string
  "Show submit test results TOOD???": string
  "Settings for custom tests": string
  "These test settings are applied to custom tests (tests created by the user)": string
  "Managed by group": string
  "The max amount of custom tests is": string
  "This option can be checked if there are no releases for this exercise. If it's checked only you will see the exercise in the group (and only you can edit it). Releases for this exercise will only work for you.": string
  "The exercise will be connected to the selected group and members with permission will be able to see/edit/delete the exercise (as long as you not checked the 'is only visible to owner' option). If your account gets deleted then the exercise can still be managed through this group": string
  "Could not reset the code": string

  //--- exerciseTestsPanel
  "Create normal test": string
  "Change normal test": string
  "Create submit test": string
  "Change submit test": string
  "Type": string
  "Points": string
  "Choose tags": string
  "Remove all": string
  "Properties": string
  "Preview": string
  "Guide": string
  "Code templates": string
  "Code template": string
  "Assets": string
  "Note": string
  "Could not save exercise": string
  "Could not update exercise": string
  "Could not create custom project": string
  "Could not update custom project": string
  "Updated exercise": string
  "If you have unsaved changes then they will be discarded. Do you want to leave the page anyway?": string
  "Create exercise": string
  "Change exercise": string
  "Save project": string
  "Export exercise": string
  "Import exercise": string
  "Lock exercise permanently": string
  "Locked permanently": string
  "Exercise is lock": string

  //--- group roles site

  "Create group role": string
  "Change group role": string
  "Delete group role": string


  //--- group role permissions
  "Can create exercises": string
  "Can change exercises": string
  "Can delete exercises": string
  "Can lock exercises permanently": string
  "Can manage exercise releases": string
  "Can copy exercises": string
  "Can see exercises from other members": string
  "Can add users to group": string
  "Can remove members from group": string
  "Can change other members group role": string
  "Can see other members": string
  "Can change group data": string
  "Submissions": string
  "Can assess exercises from group": string
  "Create group": string
  "Change group": string
  "Members": string
  "Leave": string
  "This is the default group and cannot be deleted": string
  "Only groups without exercises can be deleted": string

  //--- home site
  "On this site all open exercises are displayed (that can be solved).": string
  "On this site all your exercises are displayed (where you are the owner).": string
  "On this site all exercises of groups are displayed where you are a member.": string

  //--- manageNewUsersSite
  "Activate selected users": string
  "Delete selected users": string
  "None": string
  "Activate": string

  //--- manageTagsSite
  "Create tag": string
  "Change tag": string
  "Font color": string
  "Background color": string
  "All css colors are allowed, so also red, green, ... You can click on the brush to open a color picker.": string

  //--- ownSettingsSite
  "Old password": string
  "New password": string
  "New password again": string
  "This data can only be changed by an admin.": string


  //--- singleGroupSite
  "Add user to group": string
  "Invert selection": string
  "Is activated": string
  "Indicates if the user is already active or if this is a new user (not activated yet).": string
  "Add selected users": string
  "Group role": string
  "Is Active": string
  "Not active": string
  "Release member": string
  "This is you!": string
  "You cannot delete members from the default user group": string
  "Add member": string
  "Release selected member": string
  "User is already a member": string
  "If you change the page in the table then the selected state is lost. Thus make sure to add the users before changing the table page.": string

  //--- systemRolesSite
  "Create system role": string
  "Change system role": string
  //"Delete system role": string
  "Can create groups": string
  // "Can change group data": string
  "Can delete groups": string
  "Can create system & group roles": string
  "Can change system & group  roles": string
  "Can delete system & group  roles": string
  "Can manage new users": string
  "Can change other users system role": string
  "Can delete & view activated users": string
  "Can change other user data & view activated users": string
  "Can change system settings": string
  "Can manage tags": string
  "Can view dashboard": string
  "Can download personal data from others": string

  //tutorViewSite
  "Save manual assessment": string
  "This saves the manual assessment tab and the feedback for student tab": string
  "Manual assessment saved": string
  "There is no automatic assessment.": string
  "Normal test points": string
  "If there are no points then the automatic assessment option might be disabled (for the release) or there was an automatic assessment error.": string
  "Submit test points": string
  //"If there are no points then the automatic assessment option might be disabled (for the release) or there was an automatic assessment error.": string
  "Manual points": string
  "Points that a tutor has assigned": string
  "Not assessed": string
  "No manual points set": string
  "Note for other tutors": string
  "Feedback for student": string
  "Feedback": string
  "Feedback from tutor": string
  "Tutor-Editor": string
  "This editor is used to check and assess the submission manually. It's also used to run the tests. Any modification is NOT saved to the server. Note that the hidden files are displayed because the frontend needs all files to run tests (because the tutor editor is not persistent).": string
  "Submission code": string
  "This editor displays the original submission in a readonly editor. Note that the hidden files are displayed because the frontend needs all files to run tests (because the tutor editor is not persistent).": string
  "Subsequent editor code": string
  "This editor displays the original submission in a readonly editor. Note that the hidden files are displayed because the frontend needs all files to run tests (because the tutor editor is not persistent). Note that the hidden files are displayed because the frontend needs all files to run tests (because the tutor editor is not persistent).": string
  "Manual assessment": string
  "The submit tests results are only displayed after the automatic assessment has finished. Note that these submit tests are executed on the submit test server (not the normal test server), so there might be different settings e.g. timeouts": string
  "The release is still open.": string
  "The release is still open or the automatic assessment has not finished yet": string
  "There was no assessment object found thus the assessment cannot be saved (this normally happens if the release is still open or automatic assessment hasn't finished yet": string
  "The release is still open or the automatic assessment has not finished yet. Some inputs might be disabled": string
  "Tutor-Tests": string
  "Tutor-Submit-Tests": string
  "These tests are run with the Tutor-Editor content. Results are only temporarily and not saved on the backend.": string
  "These are the test results from the user with the subsequent editor content.": string
  "The next/previous feature is only available if you came here from the submissions-list and submissions-list is sorted by 'lastName', all submission are loaded (page size 'all'), the search text is empty and there are more than 1 submission in total": string
  "Click here to set the right settings for the submissions-site and load the required data": string
  "Could not load submissions-list data": string
  "The results from the subsequent solution normal tests": string

  //--- manageOwnOrGroupExerciseComponents
  "Only visible to me": string
  "Solutions": string
  "Releases": string
  "This copies the exercise on the server and opens the edit exercise site.": string
  "The exercise can only be deleted if it has no releases.": string
  "Could not copy exercise": string

  //--- submissionsSite
  "Refresh view": string
  "Export assessments as csv": string
  "Upload assessments from csv": string
  "Download all submissions": string
  "The .zip file contains a file called assessments.csv which can be filled and uploaded again (manual points, feedback, notes for other tutors are taken). Make sure you use a RFC 4180 compliant library for writing to the csv (that handled special cases e.g. new lines and escapes), comment lines start with #. Some users might have invalid characters in their names so the folder name contains then the user id instead." : string
  "You can import the .csv file from the 'download all submissions' feature here. At least the columns UserId, PLangId, ManualPoints, NoteForOtherTutors, FeedbackForStudent are needed. The columns ManualPoints, NoteForOtherTutors, FeedbackForStudent are used to overwrite the values in the backend. The first line must be a comment (starting with #) containing the release code. If the upload was successful then the view is automatically refreshed": string
  "Re-run automatic assessments": string
  "This re-runs all submit tests (and normal tests if specified in the release) and preserves the manual points and comments (for student, other tutors). This is also the case for single re-run.": string
  "The summed normal test points. The percentage represent the students where all normal tests passed and the participation should count. If the auto assessment was not run/finished yet the sum of positive tests are displayed (only the test that the user actually executed).": string
  "The summed submit test points. The percentage represent the students where all submit tests passed and the participation should count. If the auto assessment was not run/finished yet the sum of positive tests are displayed (only the test that the user actually executed).": string
  "with all points": string
  "Download": string
  "Re-run": string
  "Open as tutor": string
  "In the tutor view you can view the submission, the test results and manually assess the submission.": string
  "Submissions of": string
  "submissions of": string
  "Error downloading the csv data. Make sure the delimiter is not empty.": string
  "Should not count": string
  "The times the user solved this exercise (e.g. in different releases). If a user solved the exercise (release) in different programming languages then two rows are shown but it's the same participation. The participation is counted as one because the restrictions (e.g. lef time, should not count) are stored in the participation.": string
  "Could not re-run all automatic assessments": string
  "The re-run all automatic assessments has started. To get updates refresh the list": string
  "The assessment (normal and submit tests) is run on the submit test server which might have other settings (e.g. timeout). The tutor view runs the submit tests on the submit test server and the normal test on the normal test server. If normal and submit tests are run and the normal tests produce some server error (e.g. connection to test server timed out) then the submit tests are not executed.": string

  "The graph only includes data displayed in the table": string


  //--- assessment states
  "The release is still released (active).": string
  "The automatic assessment option is not selected, tests won't run but a dummy assessment will be added automatically": string
  "The automatic assessment is activated but has not ran yet.": string
  "The release was not released yet.": string
  "The automatic assessment ist still running... Refresh the view to see progress.": string
  "The automatic assessment has finished": string
  "The manually started automatic assessment has finished.": string
  "The automatic assessment has finished with errors!": string
  "Automatic refresh view": string
  "Automatic refresh view in": string
  "Nevertheless the normal test results of the users latest solution are displayed.": string
  "Are you sure you want to re-run the automatic assessment for this student?": string
  "Export": string
  "as csv": string
  "If unchecked the column will not be exported": string
  "Csv delimiter": string
  "Replace rules": string
  "Regex": string
  "Flags": string
  "e.g. ^test$ or just test": string
  "Only first matched regex rule is applied, the whole cell value is replaced. If none matched (or no rules) the else rule is applied (if it has content). Also note that the replace rules are not applied in the preview.": string
  "To match empty content use ^$. It also a good idea to use the start position, end position operators and the ignore case flag. You can test your regex at": string
  "If none matched": string
  "Only applied if the replace text is not empty": string
  "On match replace with": string
  "Additional columns": string
  "Value is a number": string,
  "There is already a column with this name:": string
  "The given string is not a valid regex:": string
  "Error in column": string
  "Error while downloading the csv file": string

  //--- releasesSite
  "Releases for": string
  "Create release": string
  "Change release": string
  "Is visible for all": string
  "If the release is visible for all then every user can see the release without entering the code. If the exercise 'is only visible to owner' then the release cannot be visible for all and only the owner can enter the release code": string
  "Automatic": string
  "Unlimited": string
  "unlimited": string
  "Start at": string
  "The actual date and time when the release was released. If the release is not yet released then this is empty.": string
  "End at": string
  "This cannot be changed after the release is created": string

  //--- changeExerciseReleaseDialog
  "The exercise is only visible to the owner and thus all releases for this exercise will only work for the owner": string
  "Start/End of the release": string
  "Automatic start at": string
  "Automatic end at": string
  "Duration of the automatic release": string
  "To end the release anyway select the manual mode and end the release manually.": string
  "Infinitely": string
  "Limited": string
  "Options": string
  "Exam options": string
  "Run automatic assessment": string
  "After the release ended the automatic tests will be run. Note that it can take up to 1 tick (1 minute) until the assessment will start.": string
  "Run normal tests too": string
  "Normally only the submit tests are run. With this optin enabled the normal tests are also run. This will overwrite the test results from the users.": string
  "Note that you will be the only user who can enter the release code because the exercise has 'is only visible to owner' set": string

  //--- custom projects sites
  "Manage custom projects": string
  "Create custom project": string
  "project(s) left": string
  "Could not load custom projects": string
  "Could not delete custom project": string
  "Delete custom project": string
  "Are you sure you want to delete your project?": string
  "Programming language for custom project": string

  //--- others (maybe move into proper (top) categories

  "Is released": string
  "If you want to start the release then tick the checkbox and save. To end a release uncheck the checkbox and save. If you re-start a release the assessment results are not deleted, so there might be old results until a new assessment is started/finished": string
  "Automatic assessment is still running... please reload the page to get new values": string
  "If you end the release now then the automatic tests will run": string
  "If you end the release now then the automatic tests will NOT run (because you didn't tick the option. If you want to run the tests tick the option first and then end the release.": string
  "All": string
  "Has limited working time": string
  "Change user data": string
  "Generated password": string
  "Resets the password for the selected user to a randomly generated password and displays it": string
  "Not selected": string
  "Click to open a new tab with all possible icons. Then past the icon text here.": string
  "The description is only displayed on hover.": string
  "All whitespaces of the input are replaced with · and all tabs with ⇥": string
  "All whitespaces of the output are replaced with · and all tabs with ⇥": string
  "Could not get html element with specific id": string
  "The solution programming language is not known": string
  "Could not find editor file": string
  "Could not find code template": string
  "Some url parameters were not found/set": string
  "Probably no test has run": string
  "Could not find programming language for given id": string
  "Could not find solution file": string
  "Could not select solution file": string
  "Could not convert string to int": string
  "Could not find release": string
  "Something went wrong calculating left working time": string
  "If the editor has unsaved changes and you run a test then the files will be auto saved before running the test": string
  "These are the submit tests. They are executed and visible after the release ended and the automatic assessment has run.": string
  "This is the result of the manual assessment. It is only visible if the tutor has left feedback or manual points for you.": string
  "If you assign manual points or feedback for the student then the manual points-and-feedback-panel is displayed to the student.": string
  "You can assign more points than the max manual points value" : string


  "Assessment statistic": string
  "Error during assessment (before or after testing, e.g. test server is offline)": string
  "Error during testing": string
  "Last editing ip address": string
  "Click to expand all": string
  "My assessment statistic": string
  "An overview what exercise you have started and how much points you got.": string
  "My Projects": string
  "Exercise": string
  "The date & time when the solution (or the participation e.g. custom tests) got last updated": string
  "Clear test results": string
  "These tests are executed using the subsequent editor content. They are available when you cannot longer edit your original solution.": string
  "These submit tests are executed using the subsequent editor content. They are available when the automatic assessment ran. Note that these submit tests are executed on the normal test server (not the submit test server), so there might be different settings e.g. timeouts. Ask a tutor to execute your submit tests on the submit test server": string
  "The automatic start/end can take up to 1 min (1 tick) until it's executed. If the automatic start is before now then the start is executed within the next tick.": string
  "Tags filter": string
  "The selected tags are connected via the selected logical operation. E.g. if you select AND and two tags then both tags needs to be assigned to the exercise. If you click a tag twice then the exercise must not have the tag assigned.": string
  "Displays the remaining time. Click to show/hide. If the remaining time is <= ": string
  " the icon color will change.": string
  "The console arguments for the program. Separated by whitespaces.": string
  "Compiled": string
  "Could not restore the editor sessions because found multiple matching editor sessions for one file. Please save all Files and reload the site.": string
  "Could not restore the editor sessions because found no editor sessions for one file. Please save all Files and reload the site.": string
  "Could not find the exercise": string
  "Could not find the exercise or no permission": string
  "Could not create new file because there is already a file with the same name.": string
  "Could not create new file because it has an invalid filename. It must be alphanumeric, start with a letter, can contain '-' and '_'": string
  "Could not rename file because it has an invalid filename. It must be alphanumeric, start with a letter, can contain '-' and '_'": string
  "Could not rename file because there is already a file with the same name.": string
  "Server version:": string
  "The time when the latest solution was saved/created on the server.": string
  "Time is up": string
  "Parse Error": string
  "Regex Error": string
  "Escape editor": string
  "Escaped result": string
  "Note that only the first automatic un-release will run the automatic assessment (if the option is checked), for all following un-releases you will need to use the manual (un-)release mode in order to run the automatic assessment": string //this is because not implemented you can't reopen with automatic end? and hasAssessment started is never reset
  "This automatic assessment is running, thus the release cannot be edited currently. Refresh the site to check again": string

  "Your participation will not be counted (nevertheless a tutor might assess your submission, it's just an info for the tutors), this cannot be undone! This does not affect the left working time.": string
  "The assessment result/participation should not be counted.": string
  "Participation should not count": string
  "Are you sure you want that your participation should not be counted? This cannot be undone!": string
  "Could not set 'participation should not count'.": string
  "Now loading test assets (before exporting)...": string
  "Could not load test assets": string
  "Could not create custom project because you exceeded the max amount of possible custom projects.": string
  "Could not load custom project": string
  "Created custom test": string
  "Updated custom test": string
  "Deleted custom test": string
  "Could not create custom test": string
  "Could not update custom test": string
  "Could not delete custom test": string

  //--- dashboard site

  "Server settings": string //actually server system settings but might be confusing because app settings are more static than these
  "These are the server (system) settings which can be configured through the frontend ui (menu - System settings).": string
  "Server constants": string
  "These settings are the server constants and are fixed after compiling (hardcoded).": string
  "Server app settings" : string
  "These settings are the app settings and can be overwritten in appsettings.json file. These are fixed after the server process is started.": string
  "Public test server settings": string
  "All test server settings (including private)": string
  "Public submit test server settings": string
  "All submit test server settings (including private)": string
  "Logical usage statistic": string
  "Property": string
  "Value": string
  "Hardware charts": string
  "CPU": string
  "RAM": string
  "free": string
  "This view/panel is live and will automatically refresh (not the whole site). Click to stop automatic refreshing": string
  "Click to make the view automatically refresh": string
  "Hide release in overviews": string
  "Hide in overviews": string
  "Hides the release from the users in all exercise overviews and statistic views": string
  "Hide print options": string
  "This will hide all print options (e.g. print task description, code editor)": string
  "Hide leave exercise actions": string
  "This will hide all actions and buttons the user could use to leave the exercise (and e.g. select another exercise). The buttons in the site header bar are not affected (use the appropriate option for that).": string
  "Show additional log-button": string
  "This will show an additional log button because some options might hide the user header bar thus one cannot show the log and e.g. download the log": string
  "Clear clipboard on focus (EXPERIMENTAL, known issues)": string
  "Clear clipboard": string
  "Shows an overlay to resume when the window/tab lost focus. This will clear the clipboard when accepted else the user can't proceed.": string
  "Hide site header bar": string
  "Hides the header bar (checked) or displays it (unchecked). The site header bar is the topmost bar where the site menu, user menu is located.": string


  //--- system settings site
  "System settings": string
  "Save system settings": string
  "When the site is loaded the current system settings are loaded from the server and also when the system settings get saved. The system settings (including the server message) are updated for every user every ~": string
  "Server message": string
  "The server message is displayed to all users in the top header bar and is always visible (at least as an icon). To remove the message just clear the input": string
  "Could not update system settings": string
  "You can click on the icon to disable its animation/change the color to normal for this session": string
  "Programming languages": string
  "Internal name": string
  "The internal name is used for requests to the test server to identify the programming language. It must match the some language known to the test server.": string
  "File extensions with dot": string
  "You need to add the file extensions for this programming language in order to get syntax highlighting in the editor. Values must be separated by , (comma).": string
  "Editor highlight": string
  "The language mode for the editor to use when the file extension matches.": string
  "Are you sure you want to delete this programming language?": string
  "Just for display purposes": string
  "Click to open the test server configuration page": string
  "This setting is only for the frontend and backend to know the programming languages. You need to add new programming languages also to the test server in order to run tests!": string

  "Languages": string
  "Note that adding a language here will not automatically translate all text. To add a new language you need to change the sources and add a file in the i18n directory. You can see i18n/en.ts for an example. After that you need to add the language to i18n/i18nRoot.ts in the KnownLangs enum where the value must be the same as the language shortcut in this table.": string
  "Shortcut": string
  "Are you sure you want to delete this language?": string
  "The shortcut code is used to identify the language internally. There must be a lagnuage file (i18n) for that shortcut to work.": string
  "At least one language needs to be there": string

  "Max number of custom tests per release": string
  "Custom tests are stored in the participation to one release. This is the maximum number of tests the user can create for one release. This will prevent the user from creating more tests than this number but will never deleted old tests. You can use a negative number for unlimited. ": string
  "Max number of custom projects": string
  "This will prevent the user from creating more custom projects than this number but will never deleted old projects. You can use a negative number for unlimited.": string
  "Max number of tests with one request": string
  "The max number of tests the user can run with one request on the normal test server (run all tests button). This must be less or equal to the max allowed tests with one request on the normal test server.": string
  "Max number of submit tests with one request": string
  "The max number of submit tests the assessment or user can run with one request on the submit test server. This must be less or equal to the max allowed tests with one request on the submit test server.": string
  "Test server timeout in ms": string
  "The max time to wait for a response from the test server in ms before a timeout error is raised.": string
  "Submit test server timeout in ms": string
  "The max time to wait for a response from the submit test server in ms before a timeout error is raised.": string
  "Test server url": string
  "Submit test server url": string
  "Test server stats url": string
  "The test server status url to get test server settings.": string
  "Submit test server stats url": string
  "The submit test server status url to get test server settings.": string
  "Test server config ui url": string
  "Submit test server config ui url": string
  "Resets this setting to the initial value": string
  "Test server Trace log api url": string
  "The test server trace log api url to remove old trace log entries.": string

  "Just run program timeout": string
  "Just run program compile timeout": string
  "Just run program max RAM in kb": string
  "Just run program max disk space in kb": string

  "Custom project test timeout": string
  "Custom project test compile timeout": string
  "Custom project test max RAM in kb": string
  "Custom project test max disk space in kb": string

  "Default user group": string
  "The default group for all new users": string
  "Default group role": string
  "The default group role when adding users to a group": string
  "Default group creator role": string
  "The default role for users who create a new group (needs permission to manage group e.g. to add first users)": string

  //--- compare test
  "Compare files options": string
  "Ignore case": string
  "Ignore all additional empty lines in the user file": string
  "Ignore leading whitespaces": string
  "This will ignore all leading whitespace characters (including tabs)": string
  "Ignore trailing whitespaces": string
  "This will ignore all trailing whitespace characters (including tabs)": string

  "This file cannot be removed because it is part of the compare files test": string

  "For a compare files test you need to add files in the test files tab": string
  "A compare test line must be placed after all black box test lines": string
  "Could not find file with name": string

  "Manage asset files": string
  "Attached Files" : string
  "All Files": string

  "These are all files from custom projects and custom exercise tests." : string
  "These are all files from exercise tests where you have the group permission to change the exercise and the exercise is visible to all." : string
  "These are all files from exercise descriptions where you have the group permission to change the exercise and the exercise is visible to all." : string

  "Note that when you detach a file and it has no connection to another exercise, it will get deleted!": string
  "Managing assets is only allowed for saved exercises (not for new exercises)": string
  "All changes to assets are applied immediately in the backend (saving is not needed for this)!": string
  "Managing test asset files is only allowed for saved tests (not for new tests)": string

}

interface LangMap {
  [lang_id: string]: LangObj
}

export enum KnownLangs {
  english = 'en'
}

/**
 * the keys must match
 * @link KnownLangs
 */
const i18n: LangMap = {
  'en': lang_en
}

export function getI18n(lang_id: KnownLangs, messageKey: keyof LangObj): string {
  const message = i18n[lang_id][messageKey] //we cannot use the key as message because that is only valid for eng

  if (message.indexOf('<') !== -1 || message.indexOf('</') !== -1) {

    const err_mesg = `The message '${message}' with the key: ${messageKey} for the lang: ${lang_id.toString()} contains html markup (< or </) but was not rendered with the proper function, use getRawI18n`
    if (isProduction) {
      //nothing
      Logger.error(err_mesg)
    } else {
      Logger.error('Error', err_mesg)
      return 'TRANSLATE ERROR'
    }
  }

  return message
}

export function getRawI18n(lang_id: KnownLangs, messageKey: keyof LangObj): { __html: string } {
  return {
    __html: i18n[lang_id][messageKey]
  }
}
